/**
 * 夜视效果
 * Translate from http://blog.csdn.net/candycat1992/article/details/39482593
 */

#ifdef GL_ES
precision highp float;
#endif

// uniform float timeElapsed;
// uniform float randomValue;
// uniform float vignetteAmount;
// uniform float effectAmount;


uniform sampler2D vignetteTexture;
uniform sampler2D noiseTexture;
uniform sampler2D scanlineTexture;

varying vec2 v_texCoord;

void main(void)
{	
	vec4 nighteyeColor = vec4(0.0, 0.8, 0.1, 1.0);
	// float sinTime = sin(timeElapsed);

	vec4 renderTex = texture2D(CC_Texture0, v_texCoord);

	vec4 vignetteTex = texture2D(vignetteTexture, v_texCoord);

	vec4 noiseTex = texture2D(noiseTexture, v_texCoord);

	vec4 scanlineTex = texture2D(scanlineTexture, v_texCoord);

	// float lum = dot(vec3(0.299, 0.587, 0.114), renderTex.rgb);
	float lum = dot(vec3(0.222, 0.707, 0.071), renderTex.rgb);
	// add brightness
	lum += 0.25;

	vec4 finalColor = lum * 2.0 + nighteyeColor;

	// finalColor = pow(finalColor, 3.18);
	finalColor.r = pow(finalColor.r, 3.18);
	finalColor.g = pow(finalColor.g, 3.18);
	finalColor.b = pow(finalColor.b, 3.18);

	finalColor *= vignetteTex;
	finalColor *= scanlineTex * noiseTex;
	
	gl_FragColor = finalColor;
}
