/**
 * Translate from http://blog.csdn.net/candycat1992/article/details/39430357
 * 老电影效果
 */

#ifdef GL_ES
precision highp float;
#endif

// uniform float timeElapsed;
uniform float randomValue;
uniform float vignetteAmount;
uniform float effectAmount;

// uniform vec4 sepiaColor;

uniform sampler2D vignetteTexture;
uniform sampler2D dustTexture;
uniform sampler2D scratchTexture;

varying vec2 v_texCoord;

void main(void)
{	
	vec4 sepiaColor = vec4(0.439216, 0.258824, 0.078431, 1.0);
	// float sinTime = sin(timeElapsed);
	float sinTime = 1.0;
	vec2 renderTexCoord = vec2(v_texCoord.x, v_texCoord.y + (randomValue * sinTime * 0.005));
	vec4 renderTex = texture2D(CC_Texture0, renderTexCoord);

	vec4 vignetteTex = texture2D(vignetteTexture, v_texCoord);

	vec2 scratchCoord = vec2(v_texCoord.x + (randomValue * sinTime * 0.05), v_texCoord.y + (randomValue * sinTime  * 0.05));
	vec4 scratchTex = texture2D(scratchTexture, scratchCoord);

	// vec2 dustCoord = vec2(v_texCoord.x + (randomValue * sinTime), v_texCoord.y + (randomValue * sinTime));
	vec4 dustTex = texture2D(dustTexture, scratchCoord);

	// float lum = dot(vec3(0.299, 0.587, 0.114), renderTex.rgb);
	float lum = dot(vec3(0.222, 0.707, 0.071), renderTex.rgb);

	vec4 finalColor = lum + mix(sepiaColor, sepiaColor + vec4(0.1, 0.1, 0.1, 0.1), randomValue);

	vec3 constantWhite = vec3(1.0, 1.0, 1.0);
	
	finalColor = mix(finalColor, finalColor * vignetteTex, vignetteAmount);
	finalColor.rgb *= mix(scratchTex.rgb, constantWhite, randomValue);
	finalColor.rgb *= mix(dustTex.rgb, constantWhite, (randomValue * sinTime));
	finalColor = mix(renderTex, finalColor, effectAmount);
	
	gl_FragColor = finalColor;
}
